SUBROUTINE BadImageList(numbadfile)

!   ****************************    NOTICE   **************************** 
 
!    This "Image Quality of Fingerprint" (IQF) software was developed by 
!                            The MITRE Corporation
!    and was produced for the U.S. Government under Contract numbers 
!    W15P7T-05-C-F600 and W15P7T-07-C-F600 and is subject to the Rights in
!    Data General clause, at FAR 52.227-l4.
	
!   Redistribution and use in source and binary forms, with or without
!   modification, are permitted provided that the following conditions are met:
	
!    -Redistribution of source code must retain the above copyright notice,
!    this list of conditions, and the following disclaimer.
	
!    -Redistribution in binary form must reproduce the above copyright
!    notice, this list of conditions and the following disclaimer in the
!    documentation and/or other materials provided with the distribution.
	
!    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
!    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
!    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
!    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
!    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
!    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
!    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
!    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
!    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
!    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
!    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
      
!   ********************************************************************* 
 
 
USE GLOBALDATA
 

INTENT (INOUT) :: numbadfile

numbadfile = numbadfile + 1

IF(numbadfile > maxbadimages) THEN
	PRINT*, ' '
	PRINT*, ' '
	PRINT*, 'QUITTING: there are fatal problems in more than ',maxbadimages, ' images'
	PAUSE 'check imagefile locations, InputDataFile setup, available memory, etc.'
	STOP
ENDIF

badfilelist(numbadfile) = TRIM(imgID)

IF(ALLOCATED(image))   DEALLOCATE(image)
IF(ALLOCATED(power))   DEALLOCATE(power)
IF(ALLOCATED(datar))   DEALLOCATE(datar)
IF(ALLOCATED(datai))   DEALLOCATE(datai)
IF(ALLOCATED(workr))   DEALLOCATE(workr)
IF(ALLOCATED(worki))   DEALLOCATE(worki)
IF(ALLOCATED(xcoord))  DEALLOCATE(xcoord)
IF(ALLOCATED(ycoord))  DEALLOCATE(ycoord)

END SUBROUTINE BadImageList
