      SUBROUTINE help () 
                                                                                                                                  
      
	PRINT*, '**********************   MITRE PROGRAM NOTICE   **********************' 
	PRINT*, ' ' 
	PRINT*, '    This "Image Quality of Fingerprint" (IQF) software was developed by' 
	PRINT*, '                         The MITRE Corporation'
	PRINT*, ' and was produced for the U.S. Government under Contract numbers' 
	PRINT*, ' J-FBI-12-128, W15P7T-05-C-F600 and W15P7T-07-C-F600 and is subject to'
	PRINT*, ' the Rights in Data-General clause FAR 52.227-l4, Alt. IV (DEC 2007).'
	PRINT*, ' ' 
	PRINT*, 'Redistribution and use in source and binary forms, with or without'
	PRINT*, 'modification, are permitted provided that the following conditions are met:'
	PRINT*, ' '
	PRINT*, ' -Redistribution of source code must retain the above copyright notice,'
	PRINT*, ' this list of conditions, and the following disclaimer.'
	PRINT*, ' '
	PRINT*, ' -Redistribution in binary form must reproduce the above copyright'
	PRINT*, ' notice, this list of conditions and the following disclaimer in the'
	PRINT*, ' documentation and/or other materials provided with the distribution.'
	PRINT*, ' ' 
	PRINT*, ' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS' 
	PRINT*, ' "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT' 
	PRINT*, ' LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR'
	PRINT*, ' A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT' 
	PRINT*, ' OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,' 
	PRINT*, ' SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT' 
	PRINT*, ' LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,' 
	PRINT*, ' DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY' 
	PRINT*, ' THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT' 
	PRINT*, ' (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE' 
	PRINT*, ' OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.' 
	PRINT*, '*************************************************************************** ' 
	PRINT*, ' ' 
   	PRINT*, 'IQF program developed and coded by Norman B. Nill (retired), MITRE Corp. ' 
	PRINT*, 'Contact (MITRE MTF and IQS Assessment Team):  mtf@mitre.org'
	PRINT*, '*************************************************************************** '
	PRINT*, ' ' 
   	PRINT*, ' ' 
	PRINT*, 'IQF can either be run as a "double click" executable, '
	PRINT*, 'or from a unix-style command line (terminal mode application). '
	PRINT*, ' '
	PRINT*, 'Command-line mode:  For usage help, add -h as the argument'
	PRINT*, '                                        -hh give this larger help message'
	PRINT*, 'Command-line use without arguments will run similar to double-click mode,'
	PRINT*, 'i.e. the user will be prompted for all inputs.'
	PRINT*, ' '
	PRINT*, 'INKED or LIVESCAN IMAGE - program determines the size & location'
	PRINT*, 'of the peak IQ window (subimage); '
	PRINT*, 'LATENT IMAGE - user predefines the size & location of a single window (subimage). '
	PRINT*, 'After window size & location is defined, the actual computation of IQ is '
	PRINT*, 'exactly the same for inked, livescan, or latent image.'
	PRINT*, ' '
	PRINT*, ' '
	PRINT*, 'The double-click startup Menu asks for RunCase:' 
	PRINT*, '    (s) single image - no input file, concise output to display'
	PRINT*, '  (c,d) multiple images with concise or verbose output - input data file required'
	PRINT*, '    (f) tenprint cardscan images - verbose output, input data file required' 
	PRINT*, 'and Menus asks for ImageType:'
	PRINT*, '   (k) inked/live'
	PRINT*, '   (t) latent'
	PRINT*, ' '
	PRINT*, ' '
	PRINT*, 'EXAMPLE INPUT FILES:'
	PRINT*, 'ImageType= Inked/Live,  RunCase= c or d:'
	PRINT*, '  500  img1.pgm                      <-- ppi   ID '
	PRINT*, '  500  186  800  750  img2.tif       <-- ppi  header   width   height   ID'
	PRINT*, '  1000  0  1600  1500 img3.raw       <-- ppi  header   width   height   ID'
	PRINT*, ' '
	PRINT*, 'ImageType= Latent,  RunCase= c or d,   (latent image Must be pgm format):'
	PRINT*, '500   200  165  323  img4.pgm       <-- ppi  windowWidth  ULcol  ULrow   ID '
	PRINT*, '1000  600  333  444  img5.pgm       <-- ppi  windowWidth  ULcol  ULrow   ID '
	PRINT*, ' '
	PRINT*, 'ImageType= Inked/Live,  RunCase= f):'
	PRINT*, '0  0  500  img6.pgm                      <-- LRcol LRrow ppi   ID '
	PRINT*, '791  740  500  186  4000  2500  img7.tif <-- LRcol LRrow ppi header  width  height  ID'
	PRINT*, 'LRcol=LRrow=0 in input file directs program to find lower right corner;' 
	PRINT*, 'otherewise user defines this corner'
	PRINT*, ' '
	PRINT*, ' '
	PRINT*, 'EXAMPLE OUTPUTS: '
	PRINT*, 'IQ   ID          <--single image run output to display'
	PRINT*, 'IQ  ppi  ID      <--multiple images CONCISE RUN output to file'
	PRINT*, ' '
	PRINT*, 'Multiple images DIAGNOSTIC/VERBOSE RUN output to file:'
	PRINT*, 'IQ   contrast  avgGray  #   window_width    ULcol  ULrow    pix1    ppi   ID '
	PRINT*, 'where pix1 = gray level of pixel in UpperLeft corner of entire input image, as read by IQF, '
	PRINT*, '             (useful to verify correct polarity and header size.) '
	PRINT*, '# = number of candidate measurement windows (RunCase=d), or rollblock number (RunCase=f)'
	PRINT*, 'If RunCase=d: entire input image is output with visible frameline around peak IQ window'
	PRINT*, ' '
	PRINT*, ' '
	PRINT*, 'NOTES:'
	PRINT*, '-All latent images Must be in PGM format.'
	PRINT*, '-Inked/livescan images can be in PGM, TIFF, RAW, etc., but if not in PGM, then the'
	PRINT*, ' user must supply the format data: Headersize(bytes)  ImageWidth(pixels)  ImageHeight(pixels).'	  
	PRINT*, '-For non-PGM images an attempt is made to decipher the image polarity, but method is '
	PRINT*, ' not foolproof, if program selects wrong polarity, answer will be wrong'
	PRINT*, ' (whereas polarity for PGM images is fixed and appears to always be correct).'
	PRINT*, '-BMP file usually stores image upside down; for some images this could result in false answer.'
	PRINT*, '-Input filenames, pathnames Cannot contain blank spaces.'
	PRINT*, '-A single input file cannot contain both latent and inked/live images. '
	PRINT*, '-Image coordinate reference: if ULcorner of window coincides with ULcorner of entire image '
	PRINT*, ' then the ULcol, ULrow of that window is  0,0 (not 1,1)' 
	PRINT*, '-Tenprint cardscan input file: LRcol, LRrow is lower right corner of rollblock #1'
	PRINT*, '-All images must be uncompressed, 8 bpp grayscale. '
	PRINT*, ' '
	PRINT*, ' '	
	  
	END SUBROUTINE help   
	
     