      PROGRAM IQF                       
                                                                                                                                  

!   ****************************    NOTICE   **************************** 
 
!    This "Image Quality of Fingerprint" (IQF) software was developed by 
!                            The MITRE Corporation
!    and was produced for the U.S. Government under Contract numbers 
!    J-FBI-12-128, W15P7T-05-C-F600 and W15P7T-07-C-F600 and is subject 
!    to the Rights in Data-General clause FAR 52.227-l4, Alt. IV (DEC 2007).
	
!   Redistribution and use in source and binary forms, with or without
!   modification, are permitted provided that the following conditions are met:
!    -Redistribution of source code must retain the above copyright notice,
!    this list of conditions, and the following disclaimer.
!    -Redistribution in binary form must reproduce the above copyright
!    notice, this list of conditions and the following disclaimer in the
!    documentation and/or other materials provided with the distribution.
	
!    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
!    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
!    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
!    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
!    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
!    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
!    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
!    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
!    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
!    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
!    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
      
!   ********************************************************************* 


!  This is the Main Subroutine which sets up data and Calls all of the other subroutines.                                                                                                                                                                                              
!     The image coordinate system is such that COL=1, ROW=1 is the upper left corner of the                                                     
!     total image; thus a 1024x1024 image runs from col=1 to 1024, row=1 to 1024);
!     but a subimage has relative reference to entire image, so ULcorner of subimage
!     would be 0,0 if it coincides with ULcorner of entire image.


                                                                                                                                                                                                                                                        
      USE GLOBALDATA
	    
      
      INTEGER ::  xc, yc, peakcol, peakrow, values(8), rollblockcounter, cardpeakIQ(1000)   
      INTEGER ::  cardLRcol(1000), cardLRrow(1000), cardHdr(1000), cardWidth(1000), cardHeight(1000)  
     
      REAL ::  cardavgIQ(1000), cardContrast(1000), cardGray(1000)	
      
	 CHARACTER(len=255) :: path
      CHARACTER(len=40) :: 	cardID(1000)
      CHARACTER(len=10) :: 	time, inline
      CHARACTER(len=8) ::	date
      CHARACTER(len=5) ::	zone                                                                                         
      CHARACTER(len=1) ::	HCflag, chr, cornerbad, rollflag(1000)
      CHARACTER(:), allocatable :: wdpath

      LOGICAL :: fileINexists, fileOUTexists 

      numsubsfinal = 1

	ARGC = 0
     CALL COMMANDLINE()

	IF(ARGC == 0) THEN 

#if !defined(MSDOS)
! If the path to the executable calling the code is absolute,
! then we assume a double-click even and change the working
! directory to compensate.
! Windows handles this automatically without help.
		CALL GET_COMMAND_ARGUMENT(0,path)
		ipath = INDEX(path, '/',.true.)
		chr = path(1:1)
		IF(chr == '/' .AND. ipath /= 0) THEN
			wdpath = path(1:ipath)
			CALL CHDIR(wdpath)
		ENDIF
#endif   
  		
		DO i = 1,10; PRINT *, ' '; END DO
      		PRINT * , '*--------------------------------------------------------------*' 
      		PRINT * , '|              Image Quality of Fingerprint (IQF)              |' 
      		PRINT * , '                           ',iqfversion
      		PRINT * , '|                        MITRE Corp.                           |' 
     	 		PRINT * , '|                                                              |'
      		PRINT * , '*--------------------------------------------------------------*' 
                DO i = 1,5; PRINT *, ' '; END DO 	                                                
                                                                                                                                                                                          
1      		PRINT*, 'RunCase:'  
      		PRINT*, '  s      Single image run'  
       		PRINT*, '  c      Concise output with multiple images (I/O files)' 
      		PRINT*, '  d      Diagnostic/verbose output with multiple images (I/O files)'   	
      		PRINT*, '  f      tenprint card (10 rollblocks)'
      		PRINT*, '  h      Help'
      		PRINT*, ' '
      		PRINT*, 'ImageType:'
      		PRINT*, '     k   Inked or livescan'  
       		PRINT*, '     t   Latent'    	
    		PRINT*, '     h   Help'
    		PRINT*, ' '
    		PRINT*, 'enter:  RunCase   ImageType '
    		READ (*, fmt = '(a)') inline 
     		runtype = inline(1:1)
     		i = IACHAR(inline(1:1))
      		IF(i < 97) runtype = CHAR(i+32)		! change runtype to small letter
        	IF(runtype/='s' .AND. runtype/='c' .AND. runtype/='d' .AND. runtype/='f') THEN
      			CALL help()
      			PRINT*, ' '
      			PRINT*, ' '
      			GOTO 1
    		ENDIF
		chr = inline(2:2)
		IF(chr == ',' .OR. chr == ' ') chr = inline(3:3)   		
    		IF(chr == ' ') chr = inline(4:4)
    		IF(chr == 'k' .OR. chr == 'K' .OR. runtype == 'f') THEN
    			imgtype = 'N'
    		ELSEIF(chr == 't' .OR. chr == 'T') THEN
    			imgtype = 'L'
    		ELSE
    		     	CALL help()
      			PRINT*, ' '
      			PRINT*, ' '
      			GOTO 1
    		ENDIF
    		
    		IF(runtype=='f' .AND. chr/='k' .AND. chr/='K') THEN
    			PRINT*, 'Cardscan is always run as inked ImageType; regardless of ImageType input'
    		ENDIF
    		  
      		IF(runtype == 's' .AND. imgtype /= 'L') THEN
			PRINT*, 'Enter:   ppi   imagefilename'
			READ*, ppi, imgID
			k = LEN_TRIM(imgID)
			IF(imgID((k-3):k) == '.pgm' .OR. imgID((k-3):k) == '.PGM') THEN
				CALL PGM()	! read-in hdr,width,height of pgm format image
	  			IF(probflag == 1) THEN
	  				PAUSE 'Quitting:  cannot read image file'
	  				STOP
	  			ENDIF
			ELSE
				PRINT*, 'Enter: HdrBytes   WidthPixels   HeightPixels'
				READ*, header, totwidth, totheight
			ENDIF
			PRINT*, ' '
      		
      		ELSEIF(runtype == 's' .AND. imgtype == 'L') THEN
			PRINT*, 'Enter:   ppi  windowWidth  UpperLeftCol  UpperLeftRow   imagefilename'
			READ*, ppi, Fprintwindow, jxcoord, jycoord, imgID
			k = LEN_TRIM(imgID)
			IF(imgID((k-3):k) == '.pgm' .OR. imgID((k-3):k) == '.PGM') THEN
				CALL PGM()	! read-in hdr,width,height of pgm format image
	  			IF(probflag == 1) THEN
	  				PAUSE 'Quitting:  cannot read image file'
	  				STOP
	  			ENDIF
			ELSE
				PAUSE 'Quitting:  latent image is not in PGM format'
				STOP
			ENDIF
			PRINT*, ' '
     		ELSE
      			PRINT*, 'Enter: input data file name'
      			READ(5, fmt='(A)') auxdataname      		
				PRINT*, ' '
       		ENDIF
	ENDIF
 
     
     
   IF(runtype == 'c' .OR. runtype == 'd' .OR. runtype == 'f' ) THEN
      	INQUIRE (file = auxdataname, exist = fileINexists) 
      	IF (.NOT.fileINexists) THEN
      		PAUSE 'Quitting:  cannot find input data file'
      		STOP
      	ENDIF
      	OPEN (UAUX, file = auxdataname, action = 'READ') 	! input file
      	
      	INQUIRE (File = iqfname, Exist = fileOUTexists) 		! output file
	IF (fileOUTexists) THEN 
                IF (iqfnametype == 0) THEN 
                     	OPEN (UOUT, File=iqfname, status='REPLACE')  ! write over existing output file       
                ELSEIF(iqfnametype == 1) THEN 
                     	OPEN (UOUT, File=iqfname, status='OLD', position='APPEND')  ! append to output file                                                
                ELSE
                	PAUSE 'Quitting:  "iqfnametype" in GlobalData must be 0 or 1'
                	STOP
                ENDIF 
        ELSE 
		OPEN (UOUT, File=iqfname, status='NEW')        ! create new output file                                                            
        ENDIF  
     	
     	CALL DATE_AND_TIME(date,time,zone,values)	
!    	WRITE(UOUT,*) CHAR(12)
     	WRITE (UOUT,90)  values(2), values(3), values(1), values(5), values(6), values(7), TRIM(iqfversion)	   
90   	FORMAT(//,' mdy: ',I2,'/',I2,'/',I4,'     hms: ',I2,':',I2,':',I2,'     IQF ',A)
	
	WRITE(UOUT, *) 'input data file:   ', trim(auxdataname) 
	WRITE(UOUT, *) ' '
	IF(runtype == 'd' .OR. runtype == 'f') THEN 
	   IF(SubImageInfo == 'N') THEN 	
	     	WRITE(UOUT, *) '....IQ........Contrast...avgGry...n....Width...Col...Row....pix1...ppi'	   
      	   ELSE
      	   	WRITE(UOUT, *) '....IQ........Contrast...avgGry..Width...Col...Row....pix1...ppi'
      	   ENDIF
      	ENDIF
      	
      	IF(runtype == 'c') WRITE(UOUT, *) '......IQ..........ppi'  
      	      
   ENDIF	     
 

  numbadfile = 0        ! counter for unreadable images in InputDataFile 	 
  
   DO 999 ifile = 1, 1000000 	! MAIN OUTER LOOP: go thru all images listed in inputdatafile, up to 1 million  	

	   	probflag = 0	! everything OK unless probflag=1        
		ALLOCATE (xcoord(2000), ycoord(2000)) 
				
		IF(runtype == 'c' .OR. runtype == 'd' .OR. runtype == 'f') THEN	! multiple images run, from input file list	
			CALL READAUX (iendrun, numsubsfinal)  
			IF(probflag == 1) THEN
				PRINT*, '**** Skipping this image (wrong setup in InputDataFile):    ',imgID
				CALL BadImageList(numbadfile)
				GOTO 999
			ENDIF 	 
			IF(iendrun == 1) EXIT	! last image  already completed
		
		ELSEIF(runtype == 's' ) THEN
			IF(ifile > 1 ) EXIT
			IF(imgtype == 'L') THEN
				xcoord(1) = jxcoord;        ycoord(1) = jycoord
			ENDIF
		ENDIF


		IF(ppi < 50) THEN	! avoids possible crash
			PRINT*, '**** Skipping this image, ppi < 50     ',imgID
			IF(runtype /= 's') CALL BadImageList(numbadfile)
			GOTO 999
		ENDIF 	 


		ALLOCATE (image(totwidth,totheight), stat=ierr)
		IF(ierr /= 0) THEN
			PRINT*, 'image memory allocation failed for:   ', imgID
			CALL BadImageList(numbadfile)
                	GOTO 999 
		ENDIF

		iheader = header   
		itotwidth = totwidth
		itotheight = totheight
		CALL READIMAGE (itotwidth, itotheight, iheader, ipixel) 	! pixels stored in int*2 array: image(col,row)		
		IF(probflag == 1) THEN
			PRINT * , '**** Skipping this image, fatal problem    ', imgID 
                	CALL BadImageList(numbadfile)
			GOTO 999
		ENDIF  




  ! **********************************************************************************************************     
  ! TEN-PRINT CARDSCAN PROCESSING: Set up for processing each rollblock in cardscan as separate image   
        rollblockcounter = 1
   	IF(runtype == 'f' .AND. rollblockcounter == 1) THEN
    		CALL CARDSCAN(meas_box_width, meas_box_height, cornerbad)    ! locates each rollblock in cardscan image()
        	ALLOCATE (cardimage(totwidth,totheight), stat=ierr)
		IF(ierr /= 0) THEN
			PRINT*, 'cardimage memory allocation failed for:   ', imgID
			CALL BadImageList(numbadfile)
                	GOTO 999 
		ENDIF       			
       		cardimage = image   ! use cardimage() to store entire cardscan, then use image() to store each rollblock subimage    
       		cardID(ifile) = TRIM(imgID)
       		cardavgIQ(ifile) = 0.	 
       		cardpeakIQ(ifile) = 0
       		cardContrast(ifile) = 0.
       		cardGray(ifile) = 0.
       		cardLRcol(ifile) = LRcol
       		cardLRrow(ifile) = LRrow
       		cardHdr(ifile) = header
       		cardWidth(ifile) = totwidth
       		cardHeight(ifile) = totheight
        	totwidth = meas_box_width
       		totheight = meas_box_height
         ENDIF				
888      IF(runtype == 'f') THEN
       	 	n = rollblockcounter	
       	 	IF(ALLOCATED(image))   DEALLOCATE(image)
       	 	ALLOCATE(image(meas_box_width, meas_box_height))
       	 	DO icol = 1, meas_box_width 
       			DO irow = 1, meas_box_height
       				image(icol,irow) = cardimage(ULrollcol(n)+icol-1, ULrollrow(n)+irow-1)
       			END DO
       	 	END DO
       	        rollblockcounter = rollblockcounter + 1
         ENDIF
   ! *****************************************************************************************************     
      
       
       
   		peakprelim_IQ = -10.
		peakcol = 0
		peakrow = 0
		
!		Fprint subroutine finds fprint in image & defines multiple window locations for IQ measurement (inked or livescan fprints)
!		For latent fprint user must predefine single window location, so Fprint subroutine is skipped		
		IF(imgtype /= 'L') CALL FPRINT (numsubsfinal)			
 		IF(numsubsfinal == 0) THEN
			PRINT*, '(image width or height) < (min FprintWindow)   ', imgID
			IF(runtype /= 's') THEN
				CALL BadImageList(numbadfile)
                		GOTO 999 
                	ELSE
                		PAUSE
                		STOP
                	ENDIF
		ENDIF



! MAIN INNER LOOP, PROCESS EACH SQUARE SUBIMAGE
                                                                       
      DO 997 num = 1, numsubsfinal 	
            ylength = Fprintwindow	! keep width & height separate to accommodate potential future rectangle window
            xlength = Fprintwindow 
            xc = xcoord(num) 	
            yc = ycoord(num) 
            HCflag = ' '              
                                                                                                                                                                                                                                                                    
! 	    Convert 2-D int*2 subimage array to 1-D real array, datar(), for input to FFT                                                                      
!           (row by row, left to right each row)                                        
	    ALLOCATE (datar(xlength*ylength), stat=ierr)
     	    ALLOCATE (datai(xlength*ylength), stat=ierr)
     	    kji = MAX(xlength, ylength)
     	    ALLOCATE (workr(kji), stat=ierr)
     	    ALLOCATE (worki(kji), stat=ierr)
	    IF(ierr /= 0) then 
		PRINT*, '**** Memory allocation failed for FFT input array   ', imgID
                CALL BadImageList(numbadfile)
            	GOTO 999
	    ENDIF 				 
	    n=1
     	    DO icol = (xc+1), (xc + xlength)	
     		DO irow = (yc+1), (yc + ylength)
			datar(n) = REAL(image(icol,irow))
			n=n+1
		END DO
     	    END DO                                                                                                                   
     
	    CALL FFT () 
 
! 	   Compute power as 2-D array, from the 1-D output arrays of FFT:
! 	   datar (real part) and datai (imaginary part)				
	    ALLOCATE (power(0:xlength/2, -ylength/2:ylength/2), stat=ierr) 
	    IF(ierr /= 0) then
		PRINT*, '**** Memory allocation failed for power()        ', imgID
                CALL BadImageList(numbadfile)
            	GOTO 999
	    ENDIF 
            power = 0.0                                                                                                                                                                                                                                    
            IF(mod(xlength,2) /= 0) THEN
			ix = 2	! xlength is odd
	    ELSE
			ix = 1	! xlength is even
  	    ENDIF
	    DO icol = 0, xlength/2 		! take advantage of bilateral symmetry
			k = icol * xlength + 1
			DO irow = 0, -ylength/2, -1
				power(icol,irow) = datar(k)**2 + datai(k)**2
				k = k+1
			END DO
	     		k = icol*xlength + xlength/2 + ix
			DO irow = ylength/2, 1, -1
				power(icol,irow) = datar(k)**2 + datai(k)**2
				k = k+1
			END DO
			IF(mod(ylength,2) == 0) THEN		! ylength is even
				power(icol, -ylength/2) = 0.0
			ENDIF
	    END DO
             
            
	    DEALLOCATE (datar)
     	    DEALLOCATE (datai)
     	    DEALLOCATE (workr)
     	    DEALLOCATE (worki)
        
            CALL computeIQ (prelim_IQ, contrast, avgGray)                                                                                                                                                                          
 	    DEALLOCATE (power)  
	    IF(prelim_IQ > peakprelim_IQ) THEN
			peakprelim_IQ = prelim_IQ
			peakcol = xc
			peakrow = yc
			peakcontrast = contrast
			peakavgGray = avgGray 
	    ENDIF
	 	

!	If this option used, note that peakprelim_IQ output has Not yet been normalized/adjusted to final_IQ form	 	
	IF(runtype=='d' .AND. SubImageInfo=='Y') WRITE (UOUT,96) prelim_IQ,contrast,avgGray,FprintWindow,xc,yc,ipixel,ppi,imgID
96 	FORMAT (2E14.6, F8.1, 5I7, 2x, A)	



997  END DO 	! end of processing for given subimage
      
 
 
 
 ! Adjust PeakPrelim_IQ to get Final_IQ:
 ! Following steps are not done in computeIQ because the normalization used there (by TotPower),
 ! does a better job of locating the best window for peak IQ assessment, especially for oddball cases.
 ! (totpower somewhat suppresses contrast influence, which is good for finding best window within a given image).
 ! Final IQ in peak window is now formed from dc normalized power, which is very sensitive to contrast, 
 ! weighted by avg gray.   However, a binary/near-binary image will result in unrealistically high IQ value with 
 ! dc normalization, so, if detected as such, final IQ is deweighted.  On the other hand, a very light image 
 ! might still have good structure (good ridge detail) even though low contrast, producing unrealistically low IQ value, 
 ! so, if detected, final IQ is upweighted.
 ! Following code for final_IQ assumes prelim_IQ was total power normalized in computeIQ subroutine.	
	
			     
	! compute base IQ = xIQdc = IQdc * avgGry**2
    	xIQdc = peakprelim_IQ * (1. + peakcontrast**2) * peakavgGray**2      
    	final_IQ = xIQdc
   
   ! Adjust IQ if very high contrast/binary, or very light but good structure:
       	IF(xIQdc > maxIQ500) THEN	! if IQ > highest valid IQ then img is very highcontrast/binary, so deweight
    		yIQdc = HCfactor * xIQdc 
    		final_IQ = yIQdc
		HCflag = '*'			  ! flag very high contrast image (case of base IQ too large)
     		IF(xIQdc < 1.1*maxIQ500) THEN	  ! apply smooth transition over maxIQ500 to 1.1*maxIQ500 range
			weight= 1. + (1.1*maxIQ500 - xIQdc) / (maxIQ500 - 1.1*maxIQ500)
			final_IQ = (1.-weight) * xIQdc + weight * yIQdc
   		ENDIF
     	
     	ELSEIF(xIQdc <= maxIQ500 .AND. xIQdc >= .5*maxIQ500 .AND. peakcontrast > 1.6) THEN
     	    	yIQdc = HCfactor * xIQdc	! IQ may be in valid range but still veryhighcontrast, so deweight		
    		final_IQ = yIQdc
		HCflag = '#'			! flag very high contrast image (case of contrast>1.6)
     		IF(peakcontrast < 1.65) THEN	! apply smooth transition over 1.60 to 1.65 peakcontrast range
			weight = 1. + (1.65 - peakcontrast) / (1.6-1.65)
			final_IQ = (1.-weight) * xIQdc + weight * yIQdc  
   		ENDIF
     	
     	ELSEIF(peakavgGray > 200. .AND. peakcontrast > .1) THEN  
    		yIQdc = 2.5 * xIQdc	! some very light imgs have good structure, so upweight
    		final_IQ = yIQdc
		HCflag = '+'			! flag light, structured image
     		IF(peakavgGray < 210.) THEN	! apply smooth transition over 200 to 210 peakavgGray range
		        weight = 1. + (210. - peakavgGray) / (200. - 210.) 
			final_IQ = (1.-weight) * xIQdc + weight * yIQdc  
   		ENDIF
     	ENDIF  

    
    
 ! Final step: Normalize IQ so that IQ range is:
 !    0 (worst) to 100 (best quality) for 500ppi image
 !    0 (worst) to 200 (best quality) for 1000ppi image
 ! Raise to .333 power so IQ values within range better approximate the visual sense of relative quality levels.

	scalefactor = REAL(ppi) / 500.	! image power spectrum is inherently scale-independent, so adjust for different ppi levels
	
	IQfinal = NINT(100. * scalefactor * (final_IQ / maxIQ500)**.333)
  	
  	IF(HCflag == '+' .AND. IQfinal > NINT(99. * scalefactor)) THEN     ! sanity check/correct for light,structured image
  		IQfinal = NINT(100. * scalefactor * (xIQdc / maxIQ500)**.333)
    	ENDIF

   	
!        WRITE(5, fmt='('IQ= ',F5.1,4x,A)')
         IF(runtype /= 'f') PRINT*, 'IQ= ',IQfinal,'    ', imgID 
         IF(ppi > 1010) PRINT*, 'WARNING:  ppi > 1010, computed IQ may not be valid'
         			
        IF(runtype == 's') THEN
    		EXIT		!  finished single image processing
        ELSEIF(runtype == 'c') THEN		
      		WRITE (UOUT, 94) IQfinal, ppi, imgID
94 	     	FORMAT (I8, 6x, I8, 2x, A) 
 	ELSEIF(runtype == 'd') THEN
 		IF(SubImageInfo == 'N') THEN
 		WRITE (UOUT,93) IQfinal,peakcontrast,peakavgGray,numsubsfinal,FprintWindow,peakcol,peakrow,ipixel,ppi,HCflag,imgID
93 	     		FORMAT (I8, 5x, F8.4, F9.1, I6, 5I7, 2x, A1, A)
		ELSE
 			WRITE (UOUT, 95) IQfinal, peakcontrast, peakcol, peakrow, ipixel, ppi, HCflag, imgID
95 	     		FORMAT (I8, 5x, F8.4,'   <-peakIQ->  ', 4I7, 2x, A1, A/)		
		ENDIF		
		IF(pgmwrite == 'Y') CALL WRITEIMAGE (peakcol, peakrow, peakavgGray)
 	ELSEIF(runtype == 'f') THEN
 	 		m = rollblockcounter-1
 	 		WRITE (UOUT,93) IQfinal, peakcontrast, peakavgGray, m, FprintWindow, &
 	 				ULrollcol(m)+peakcol, ULrollrow(m)+peakrow, ipixel, ppi, HCflag, imgID
 	ENDIF
 


	IF(runtype == 'f') THEN
		cardavgIQ(ifile) = cardavgIQ(ifile) + REAL(IQfinal)
		cardContrast(ifile) = cardContrast(ifile) + peakContrast
		cardGray(ifile) = cardGray(ifile) + peakavgGray		
		IF(IQfinal > cardpeakIQ(ifile)) cardpeakIQ(ifile) = IQfinal	
		IF(rollblockcounter < 11) THEN		
			GOTO 888
		ELSE
			DEALLOCATE (cardimage)
         		DEALLOCATE (image)
			DEALLOCATE (xcoord, ycoord)
			cardavgIQ(ifile) = cardavgIQ(ifile) / 10.
			cardContrast(ifile) = cardContrast(ifile) / 10.
			cardGray(ifile) = cardGray(ifile) / 10.
			rollflag(ifile) = ' '
			IF(cornerbad == 'Y') rollflag(ifile) = '='
			PRINT*, 'CardAvg IQ= ', NINT(cardavgIQ(ifile)),'    ', imgID 
		ENDIF
	ELSE
		DEALLOCATE (image)
		DEALLOCATE (xcoord, ycoord)
	ENDIF


999 END DO 	! end of processing for given input image (or given rollblock if cardscan)
        
    
    
   IF (runtype == 'd' .OR. runtype == 'f') THEN
   	 WRITE(UOUT, fmt='(/,A)')  'Tag on ImageFileName:'
   	 WRITE(UOUT, fmt='(A)') '* or #     HighContrast/BinaryImage'
   	 WRITE(UOUT, fmt='(A)') '  +        VeryLight but StructuredImage' 
   ENDIF    
  
   IF(runtype == 'f') THEN
   	WRITE(UOUT, fmt='(A)') '  =        Possible error in locating rollblocks, check window locations'
   	WRITE(UOUT,FMT='(/,A)') 'CardScan Info:'
   	WRITE(UOUT,*) 'avgIQ..peakIQ..avgCon...avgGry...LRcol...LRrow...Hdr....Width...Height'
   	DO i = 1, ifile-1 
   		WRITE(UOUT,FMT='(I5,I8,F9.4,F8.1,1x,I7,1x,I7,3I8,4x,A1,A)') NINT(cardavgIQ(i)), cardpeakIQ(i), cardContrast(i), & 
   		       cardGray(i), cardLRcol(i), cardLRrow(i), cardHdr(i), cardWidth(i), cardHeight(i), rollflag(i), cardID(i) 
   	END DO 
   ENDIF   
  
   IF (runtype == 'c' .OR. runtype == 'd' .OR. runtype == 'f') THEN
   	PRINT*, ' '
        CLOSE (UOUT) 
        CLOSE (UAUX) 
        PRINT*, ' output file:   ', iqfname 
   	IF(numbadfile > 0) THEN
    		WRITE(UOUT,*) '***********************************************************'
    		WRITE(UOUT,*) 'Following labels were read as imagefilenames that could not'
    		WRITE(UOUT,*) 'be processed, either because image file could not be found,'
    		WRITE(UOUT,*) 'or inputdatafile was not setup correctly, or other problem:'
    		WRITE(UOUT, fmt='(A100)') (badfilelist (iz), iz = 1, numbadfile)          
   	ENDIF
   ENDIF 
  
   PRINT*, ' '
   PRINT*, ' press Return to end program'
   PAUSE                                                                                                                    
     
  END PROGRAM IQF
	  
