      SUBROUTINE readaux (iendrun, numsubsfinal) 
                                                                                                                                  
!   ****************************    NOTICE   **************************** 
 
!    This "Image Quality of Fingerprint" (IQF) software was developed by 
!                            The MITRE Corporation
!    and was produced for the U.S. Government under Contract numbers 
!    W15P7T-05-C-F600 and W15P7T-07-C-F600 and is subject to the Rights in
!    Data General clause, at FAR 52.227-l4.
	
!   Redistribution and use in source and binary forms, with or without
!   modification, are permitted provided that the following conditions are met:
	
!    -Redistribution of source code must retain the above copyright notice,
!    this list of conditions, and the following disclaimer.
	
!    -Redistribution in binary form must reproduce the above copyright
!    notice, this list of conditions and the following disclaimer in the
!    documentation and/or other materials provided with the distribution.
	
!    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
!    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
!    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
!    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
!    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
!    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
!    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
!    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
!    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
!    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
!    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
      
!   ********************************************************************* 
 
 
 
 
                                                                                                                                  
!  This subroutine:                                                                                                          
!    Reads-in InputDataFile, one line (for one image) at a time:
!       ppi  imgname          (for runtype= c  or d, pgm image)  
!       ppi  hdr  width  height  imgname      (for runtype= c or d, not pgm image)                                                                                        
!    Comment lines begin with a '#' character, blank lines are OK.                                              
!    Tab can appear just before imgname, but not any place else (better to stick with all spaces, no tabs)
!    the ImageFileName cannot include spaces
!    If file corruption is detected for a given line, that line (image) is skipped
    
                                                                                                                                  
      USE GLOBALDATA
	  	  
      CHARACTER(LEN=200) :: curline
      CHARACTER(LEN=1) :: tab=CHAR(9)
      
      LOGICAL :: backtrack=.TRUE. 
      
      iendrun = 0	! last image flag: 0 (not last),  1 (last image processed)
                                                                                                                                                 
10    READ (UAUX, fmt = '(a)', end = 260) curline 
      curline = ADJUSTL(curline)
      k = LEN_TRIM(curline)
      IF (curline(1:1) =='#' .OR. curline(2:2) =='#' .OR. k == 0) goto 10 
   
! Following method reads complete imgID first, then simple fmt=* read for data items to left of imgID     
      i = SCAN(curline(1:k),tab, backtrack)		! location of tab just before imgID (this is Only tab allowed)
      j = i
      IF(i == 0) j = SCAN(curline(1:k),' ',backtrack)	! location of space just before imgID
      imgID = curline((j+1):k)  
     
     
      IF(curline(k-3:k) == '.pgm' .OR. curline(k-3:k) == '.PGM') THEN
      		IF(imgtype == 'L') THEN		
      			READ(unit=curline, fmt=*, err=25) ppi, Fprintwindow, xcoord(1), ycoord(1)
      			numsubsfinal = 1	! Latent image inputfile: ppi subimgWidth  ULcol  ULrow imgID.pgm	
       		ELSEIF(imgtype == 'N' .AND. runtype /= 'f') THEN
        		READ(unit=curline, fmt=*, err=25) ppi 	! if not latent, subimgWidth,ULcol,ULrow not read-in
     		ELSEIF(runtype == 'f') THEN
      			READ(unit=curline, fmt=*, err=25) LRcol, LRrow, ppi	! 10-print card: LowerRight corner of rollblock 1
        	ENDIF		
      		CALL PGM()		! read-in hdr,width,height of pgm format image
	  	IF(probflag == 1) RETURN
      ELSE
		IF(imgtype == 'L') THEN
			probflag = 1	! latent image not in required pgm format
			RETURN
		ELSEIF(imgtype == 'N' .AND. runtype /= 'f') THEN
			READ(unit=curline, fmt=*, err=25) ppi, header, totwidth, totheight	! not PGM format & not Latent Img			
    		ELSEIF(runtype == 'f') THEN
      			READ(unit=curline, fmt=*, err=25) LRcol, LRrow, ppi, header, totwidth, totheight	! 10-print card
		ENDIF	
      ENDIF

      IF(imgtype == 'L') THEN
      		IF(((xcoord(1)+Fprintwindow) > totwidth) .OR. ((ycoord(1)+Fprintwindow) > totheight)) THEN
      			probflag = 1
      			RETURN
      		ENDIF
      ENDIF
       
      RETURN 	! Normal return when no problems encountered
  
                                                                                                                                    
260   iendrun = 1 		! normal return for end of file
      RETURN 
                                                                                                                                   
25    probflag = 1		! error in InputDataFile line
      RETURN 
                                                                                                                                                                                                                                                                                                                                                 
      END SUBROUTINE readaux 
	  
